--Have to copy the whole file just to insert one line :(


local always_show = {
  Xenology=set('Interstellar Expeditions'),
  Railguns=set('Advanced Field Theory'),
  ['Battle Shields'] = set('Advanced Field Theory'),
  ['Antimatter'] = set('Fusion','Advanced Field Theory'),
  ['Nanocomputers'] = set('Superconductors'),
  ['Personal Shields'] = set('Force Fields'),

  ['Stellar Surge Beam'] = set('Zero-Point Energy'),
  ['Hadron Cohesion']=set('Graviton Physics'),
  ['Warp Lane Stabilizers']=set('Antimatter','Graviton Physics'),
  ['Hellbores']=set('Zero-Point Energy'),
  ['Temporal Fields']=set('Force Fields'),
  ['Distortion Field']=set('Fusion'),
  ['Plasma Projectiles']=set('Antimatter','Plasma Focusing'),
  ['Ion Beams']=set('Fusion'),
  ['Turbolasers']=set('Fusion'),
 -- ['Matter Transport']=set('Force Fields','Zero-Point Energy'),
  ['Matter Transport']=set('Zero-Point Energy'),
  ['Force Beams']=set('Force Fields'),
  ['Marauder Raiders']=set('Slave Collars'),
  ['Subspace Networking']=set('Nanoscale Fabrication'),
  ['Nanoscale Fabrication']=set('Industrial Automation'),
  ['Quantum Decryption'] = set('Xeno-Engineering'),
  ['Industrial Replicators']=set('Matter Transport'),
  ['Zero-Point Energy']=set('Nanoscale Fabrication'),
  ['Plasma Focusing']=set('Heavy Ion Beams'),
--  ['Improved Solar Panels']=set('Nanoscale Fabrication'),
  ['Primary Artillery'] = set('Stupendous Energy Physics'),

}

local intrafield_hidden = {
    ['Quantum Decryption'] = set('Quantum Computing'),
  ['Ansible'] = set('Force Fields'),

--  ['Artificial Organisms']=set('Interstellar Expeditions'),
}

local hide_all_deps = set(
  'Advanced Field Theory',
  'Modular Outposts',
  --'Antimatter',
  --'Graviton Physics',
  --'Force Fields',
  --'Heavy Hulls',
  'Fusion',
  --'Quantum Computing',
  --'Molecular Manipulation',
  --'Zero-Point Energy'
)

source_splitter_biases = {
  ['Warp Lane Stabilizers']=3,
--  ['Zero-Point Energy']=2,
  ['Force Fields']=1,
  ['Hadron Cohesion']=2,
  ['Heavy Lasers']=1,
  ['Heavy Hulls']=1,
  ['Xenology']=3,
  ['Quantum Computing']=3,
  ['Primary Beams']=1,
  ['Low Orbit Refits']=3,
  ['Molecular Manipulation']=1,
  ['Terraforming']=1, 
  ['Graviton Physics']=3,
 -- ['Matter Transport']=3,
  --['Ion Beams']=1,
}

-- in the case of almost all tree edges, the only ones we want
-- to visualize are those that represent simple AND links.
--
-- in the case of most ORs, they should either be left to icon
-- overlays, or, in a few rare cases, hardcoded in with custom
-- placement rules.  there are 2 edges, however, both related
-- to the Orthin's unique Stupendous Energy tech, where i think
-- it makes sense to visualize them as if they were simple
-- <AND> links, even though they're technically ORs.  That's
-- because assosiated tech links have <OR>s involving late game
-- hull types which, while they do actually afford an alternate
-- route to and from the tech, are actually more, rather than
-- less, confusing if we omit the obvious implied line in favor 
-- of an on-hover tooltips.
unconventional_tree_edges = {
  ['Primary Artillery'] = set('Stupendous Energy Physics'),
  ['Stupendous Energy Physics'] = set('Heavy Ion Beams'),
}

function extra_visible_tree_edges( try_join )

  try_join('Industrial Replicators', 'Planet Construction')  

  try_join('Xenology', 'Xeno-Engineering')  

  try_join('Fusion', 'Plasma Torpedoes')  
  
  --try_join('Quantum Computing', 'Quantum Decryption')  

--  try_join('Stupendous Energy Physics','Primary Artillery')
--  try_join('Heavy Ion Beams', 'Stupendous Energy Physics')
   
  try_join('Zero-Point Energy', 'Neutronium Construction')
  try_join('Nanoscale Fabrication','Improved Solar Panels')
  try_join('Molecular Manipulation','Core-Tap Mining')
  try_join('Hadron Cohesion','Hellbores')

--  try_join('Advanced Field Theory','Zero-Point Energy')

  --try_join('Matter Transport','Food Replicators')

  try_join('Force Fields','Ansible')
  try_join('Antimatter', 'Antimatter Warheads')

  -- there's room to include this line if we really wanted to,
  -- but, customizing the primary beam OR join to work in the
  -- case that the antimatter line is also shown would require a
  -- fair amount of special case code; and even if that code were
  -- written up, we'd *still* have a problem because there's no
  -- way to visualize the hadron cohesion edge in the current
  -- column layout.
--  try_join('Antimatter', 'Primary Beams')
  try_join('Nanocomputers','Shipyards')

  --try_join('Warp Lane Stabilizers', 'Hyperspace Cloud Computing')

end


function add_custom_tree_constraints(info)
  
  function info.hide_edge(tech,prereq)
    if intrafield_hidden[tech]?[prereq] 
      return true 
    end

    if always_show[tech]?[prereq] 
      return false 
    end

    if hide_all_deps[prereq]
      return true
    end

    if (TECHNOLOGY[prereq].field~=TECHNOLOGY[tech].field) 
      return true
    end

  end


  info.eq_constraints={}

  local function force_row(...)

    for i=2,select('#',...)
      table_append(info.eq_constraints,|) {
        select(i-1,...), select(i,...), delta=0
      }
    end

  end



  force_row('Nanoscale Fabrication', 'Adamantium Construction')

  --force_row('Stupendous Energy Physics','Primary Artillery')
  force_row('Hyperspace Beacons','Pulse Generators')

  force_row('Advanced Metallurgy', 'Heavy Hulls', 'Shipyards','Carriers','Super-Dreadnoughts','Mobile Planetoid')

  force_row('Hyperspace Metrics','Subspace Communications', 'Graviton Physics', 'Hadron Cohesion','Warp Wells','Artificial Singularities')

  force_row('Antimatter', 'Warp Lane Stabilizers', 'Temporal Dynamics')
  force_row('Cloning','Weather Control','Longevity')
  force_row('Deflector Screens','Advanced Field Theory', 'Battle Shields', 'Force Fields','Temporal Fields')

  force_row('Orbital Construction', 'Escort Cruisers')

  force_row('Adamantium Construction','Neutronium Construction')
  force_row('Heavy Missiles','Fusion Torpedoes','Antimatter Torpedoes')
  force_row('Anti-Missiles', 'Fusion Anti-Missiles', 'Antimatter Anti-Missiles') -- Anti-Missile Tech MOD
  force_row('Mass Drivers','Heavy Drivers','Railguns','Force Beams')
  force_row('Leech Warheads','EMP Warhead')

  force_row('Guidance Systems','Fusion Warheads','Antimatter Warheads')

  force_row('Xenology','Alien Psychology')

  force_row('Nanocomputers','Self-Organizing Networks','Adaptive Energy Grid','Quantum Computing','Hyperspace Cloud')
  force_row('Zero-Point Energy','Matter Transport','Industrial Replicators')
  force_row('Terraforming','Planet Construction')
  force_row('Rapid Fire Lasers','X-Ray Lasers','Turbolasers')
  force_row('Fusion','Ion Beams','Heavy Ion Beams')

  force_row('Heavy Lasers','Disruptors','Primary Beams','Stellar Surge Beam')
  force_row('Heavy Ion Beams','Plasma Focusing')
  force_row('Mercenary Exchange','Hidden Bases')
  force_row('Plasma Focusing','Hellbores',)
  force_row('Interstellar Currency','Interspecies Law')


  
  --force_row('Weather Control','Longevity')

  -- none of these should be necessary, assuming the quadratic
  -- solver is actually working properly (if it's not, adapting
  -- the termination condition and/or solution method may be
  -- necessary. )
  --force_row('Galactic Stock Exchange','Race Mind')
  --force_row('Bombers','Multirole Fighters')
  --force_row('Lasers','Heavy Lasers')
  --force_row('Synthetic Foodstuffs','Food Replicators')
  --force_row('Habitat Domes','Atmosphere Generation')
  --force_row('Terraforming','Orbital Mirrors')


  info.iq_constraints = {
    {'Xeno-Engineering','Autorepair Systems',s=2},
    {'Xeno-Engineering','Bombers',s=.75},
    { 'Guidance Systems', 'Anti-Missiles' },

    {   "Fusion", "Containment Fields"},

    {'Arda Puzzle Box', 'Alien Psychology',s=1},

    --{'Pulse Generators','Warp Node Attunement',s=1.75},

    { 'Alien Psychology', 'Market Theory', s=1 },
    { 'Improved Solar Panels','Subspace Networking',  s=1.75 },

    {  'Nanoscale Fabrication', 'Advanced Turbolasers', s=3 },

    --{ 'Defense Grid','Hovertanks', s=1 },

    { 'Carriers', 'Dreadnoughts', },

    { 'Carriers', 'Battlecruiser', s=2 },
    
    --{ 'Battlecruiser', 'Dreadnoughts', delta=0 },

    {'Industrial Automation', 'Self-Organizing Networks',  s=1 },
    {'Advanced Metallurgy','Miniaturization'},
    {'Advanced Metallurgy','Magazine Bays'},
   
    {'Artificial Organisms','Modular Outposts'},
   -- {'Plasma Focusing',''}

     {'Disruptors','Plasma Focusing',s=1.5},

    { 'Adaptive Energy Grid','Zero-Point Energy', s=1.5 },
    --{ 'Longevity','Social Engineering', s=1.5 },


    { 'Temporal Dynamics','Warp Wells', s=2 },
--    { 'Temporal Dynamics','Ansible', s=1 },
    { 'Star Gates', 'Temporal Fields',s=1.5},
    { 'Star Gates', 'Ansible',s=.5},

    { 'Nanoscale Fabrication', 'Subspace Networking',  },
    { 'Nanoscale Fabrication', 'Leech Warheads',  },
   { 'Battlecruiser', 'Nanoscale Fabrication',  },

    {'Antimatter','Battle Shields'},
    {'Fusion Warheads','Leech Warheads',s=1},

    {'Boarding Tactics','Bombers',s=2},

    {'Close-In Weapons','Mass Drivers',s=1},
    {'Ion Beams', 'Viper Dynamics',s=3},
    { 'Shipyards', 'Fleet Logistics', s=2 },

  --{ 'Militia','Powered Armor', s=1 },
  {  'Powered Armor','Defense Grid', s=1 },

  {'Railguns','Fusion Torpedoes',s=1},

  {'Fusion Torpedoes','Fusion Warheads',s=1},

  {   'Deflector Screens', 'Shield Capacitors', s=1 },

   {'Subspace Networking',  'Adaptive Energy Grid' },

   {'Hovertanks','Bombers'},

--  {  'EMP Warhead','Fusion Warheads', s=1 },
  --{  'Guidance Systems','Heavy Missiles', s=1 },
  }

  info.custom_connections = {
   -- {'Low Orbit Refits','Autorepair Systems',w=5.1},
   -- {'Floating Fortresses','Race Mind',w=.1},
   -- {'Terraforming','Race Mind',w=.1},
   -- {'Planet Construction','Race Mind',w=.1},
   -- {'Super-Dreadnoughts','Race Mind',w=.1}
    --{ 'Race Mind', 'Matter Transport' },
    --{'Matter Transport','Floating Fortresses'},
    --{'Xeno-Engineering','Hidden Bases'},
    --{'Slave Collars','Trade Fleets'}
  }
end

local heavy_mount_techs = set(
  'Heavy Drivers','Heavy Missiles','Heavy Drivers', 'Primary Artillery')

local flipped_OR_hovers = set('Primary Artillery')

function override_prereq_overlay(tree_info,tech)
  local missing = tree_info.missing_prereqs[tech]

  --print(..tech)

  if missing and heavy_mount_techs[tech]
    return table.concat(missing,'\nOR '), flipped_OR_hovers[tech] and missing[#missing] or missing[1]
  end


end

local master_columns = {
  {
    "Guidance Systems",

    "Mass Drivers",

    "Star Drive",

    "Marauder Weaponry",

    "Nuclear Power",
    
    "Lasers",
    "Portable Fabrication",

    "Advanced Metallurgy",
    "Small Craft",  

    "Titanium Construction",
    "Military Doctrine",
    "Slave Collars",




   "Trade Fleets",

    "Interstellar Expeditions",

    "Star Harpies",   

  },


  {
    "Limpet Missiles", 
    "Anti-Missiles",
    "Close-In Weapons",
    "Flak Cannon",


    "Ancient Control Systems",
    "Tachyon Physics",  
    "Containment Fields",

  

    "Superconductors",    
  

    "Magazine Bays",
    "Miniaturization",
    "Orbital Construction", 
    "Asteroid Bases", 

 
    "Boarding Tactics",
    "Marauder Raiders",

    "Xenology",
 
    "Modular Outposts", 

  },
  {
    
    'Fusion Anti-Missiles',
    "Retargeting Systems",
    "Fusion Warheads",
    "Heavy Missiles",

    "Deflector Screens",
    "Hyperspace Metrics", 
    "Arda Thrust Vanes",
     "Fusion", 

    "Arda Focusing Lens",
    "Heavy Lasers",
    "Rapid Fire Lasers",

    "Nanocomputers",
  
    "Heavy Hulls",  
    "Escort Carrier",
    "Escort Cruisers",  
    "Low Orbit Refits", 
    "Bombers",  
    "Vindicators",
  
    "Market Theory",
    "Alien Psychology",

    "Artificial Organisms", 
    "Arda Warships",
  },

  {

    "Leech Warheads",
    "Fusion Torpedoes",

    "Heavy Drivers",


    "Shield Capacitors",
    "Advanced Field Theory",




    "Hyperspace Beacons",
    "Hyperspace Anomalies",
    "Subspace Communications",
    "Warp Harmonics",



    "Viper Dynamics",
    "Plasma Torpedoes",
    "Ion Beams",


    "X-Ray Lasers",


    "Industrial Automation",
    "Duranium Construction",

    "Space Habitats",

    "Shipyards",    
    "Light Carrier",  
    "Missile Cruisers",

    "Docking Fields",   
  
    "Autorepair Systems",
    "Xeno-Engineering",

    "Hovertanks",
  
    "Defense Grid",
  },
  {


    "EMP Warhead",

    "Battle Shields",    

    "Antimatter",


    "Distortion Field",


    "Ion Point Defense",



    "Heavy Ion Beams",

    "Turbolasers",

    "Self-Organizing Networks",
  

      "Nanoscale Fabrication",  
    "Fleet Logistics",  
  

      "Militia",
    "Powered Armor",
    "Mercenary Exchange",
    "Interstellar Currency",
    "Arda Puzzle Box",
    "Arda Persuasion Matrix",

     "Bionomics", 
     "Harpy Repellant",
  },

  {
    'Antimatter Anti-Missiles',
        "Antimatter Warheads",

    "Railguns",
    "Pulse Generators",
    "Warp Node Attunement",
    "Graviton Physics",

    "Neutron Beams",
    "Stupendous Energy Physics",
    "Plasma Focusing",
  "Disruptors",
  

    "Advanced Turbolasers",

      "Subspace Networking",
      "Improved Solar Panels",
      "Arda Fabrication Techniques",

    "Battlecruiser",
    "Carriers",   
  
  
    "Multirole Fighters",   
  
    "Battle Mechs",
    "Hardened Bunkers",
    "Interspecies Law",

    "Cloning",
    "Synthetic Foodstuffs",
    "Habitat Domes",
  
  
  },

  {

    "Antimatter Torpedoes",


    "Warp Node Dynamics",
    "Hadron Cohesion",
    "Warp Lane Stabilizers",


    "Plasma Projectiles",




    "Primary Beams",


    "Zero-Point Energy",


    "Adaptive Energy Grid", 
   "Adamantium Construction", 


    "Dreadnoughts", 

    "Quantum Decryption", 

    "Starfighters",
    "Civil Fortifications",

    "Hidden Bases",

    "Weather Control",
    "Atmospheric Condensation", 
  },
  {




    "Force Fields",
    "Warp Wells",
    "Temporal Dynamics",

    "Primary Artillery",
    "Hellbores",



    "Matter Transport",
    "Quantum Computing",
    "Cybernetic Organisms",
    
  
  
 
   "Molecular Manipulation",


    "Defense Network",
    "Drop Pods",

    "Longevity",
  

    "Atmosphere Generation",  
  
  },
  {

    "Force Beams",

      "Personal Shields",


    "Temporal Fields",
    "Star Gates",
    "Artificial Singularities",
    "Warp Interdictor",
  
    "Industrial Replicators",

    "Core-Tap Mining",

    "Super-Dreadnoughts",
    
    "Floating Fortresses",
    
    "Galactic Stock Exchange",  
    "Social Engineering", 
  
    "Food Replicators",   
    "Arcologies",
    "Terraforming",

  },

  {





  
   "Weaponized Singularities",

    "Ansible",



    "Ancient Star Gates",

    "Stellar Surge Beam",



    "Artificial Sentience",

    "Hyperspace Cloud", 

    "Neutronium Construction",
    
    "Mobile Planetoid",
    
  


    "Race Mind",

    "Planet Construction",
    "Sentient Ecosystems",
    "Orbital Mirrors",


    "Coral Blooms",
    "Hive Worlds",  


    "Artificial Suns",

  },
}

function load_tech_columns()
  return reverse_columns | copy | master_columns
end

if lua_load_complete
  reset_tech_tree_cache()
end